include \masm32\include\masm32rt.inc
.586	
include \masm32\macros\timers.asm

jeven MACRO value, lbl
	mov eax, value
	test eax, 1
	jz lbl
ENDM

.data
VarOdd	dd 1234567
VarEven	dd 1234568

.code
AppName	db "Masm32:", 0

start:
	Loops=10000000

	invoke Sleep, 1000
	mov eax, 12345
	counter_begin Loops, HIGH_PRIORITY_CLASS
		test eax, 1
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, eax odd",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		test VarOdd, 1
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, VarOdd",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		test VarEven, 1
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, VarEven",13,10, 10

	invoke Sleep, 1000
	mov ebx, 12345
	counter_begin Loops, HIGH_PRIORITY_CLASS
		mov eax, ebx
		test eax, 1
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, mov eax, odd",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		mov eax, VarOdd
		test eax, 1
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, mov eax, VarOdd",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		mov eax, VarEven
		test eax, 1
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, mov eax, VarEven",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		mov eax, 12345678
		test eax, 1
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, mov eax, immediate even",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		mov eax, 12345677
		test eax, 1
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, mov eax, immediate odd",13,10, 10

	invoke Sleep, 1000

	mov ebx, 12345
	counter_begin Loops, HIGH_PRIORITY_CLASS
		push ebx
		call IsOdd
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, call IsOdd, odd",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		push VarOdd
		call IsOdd
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, call IsOdd, VarOdd",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		push VarEven
		call IsOdd
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, call IsOdd, VarEven",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		push 12345678
		call IsOdd
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, call IsOdd, immediate even",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		push 12345677
		call IsOdd
		jz @F
		nop
	 @@:
	counter_end
	print str$(eax)," cycles, call IsOdd, immediate odd",13,10

	exit

IsOdd proc value:dword
	mov eax, value
	and eax, 1
	ret
IsOdd endp

end start

RichMasm options:
OPT_Linker	polink
OPT_Wait	1
OPT_Tmp2Asm	1
